// WaiterDlg.cpp : implementation file
//

#include "stdafx.h"
#include <shellapi.h>

#include "Waiter.h"
#include "WaitInfo.h"
#include "WaiterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static UINT UWM_REPOSITION = ::RegisterWindowMessage(_T("UWM_REPOSITION-{F7113F81-6D03-11d3-9FDD-006067718D04}"));


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWaiterDlg dialog

CWaiterDlg::CWaiterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWaiterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWaiterDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	running = FALSE;
	test = FALSE;
}

void CWaiterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWaiterDlg)
	DDX_Control(pDX, IDC_TEST_IMAGE, c_Image);
	DDX_Control(pDX, IDC_ASYNCHRONOUS, c_Asynchronous);
	DDX_Control(pDX, IDC_SYNCHRONOUS, c_Synchronous);
	DDX_Control(pDX, IDC_TEST, c_Test);
	DDX_Control(pDX, IDC_RUNNING, c_Running);
	DDX_Control(pDX, IDC_RUN, c_Run);
	DDX_Control(pDX, IDC_PROGRAM, c_Program);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWaiterDlg, CDialog)
	//{{AFX_MSG_MAP(CWaiterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RUN, OnRun)
	ON_EN_CHANGE(IDC_PROGRAM, OnChangeProgram)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_WM_TIMER()
	ON_REGISTERED_MESSAGE(UWM_REPOSITION, OnReposition)
	ON_EN_CHANGE(IDC_PROGRAM, OnChangeProgram)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(WaitInfo::UWM_PROCESS_TERMINATED, OnProcessTerminated)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWaiterDlg message handlers

/****************************************************************************
*                          CWaiterDlg::OnReposition
* Inputs:
*       WPARAM: ignored
*	LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Forces the window to the top left corner
* Notes:
*	This is done because the dialog handler, after OnInitDialog returns,
*	forces the dialog to be centered
****************************************************************************/

LRESULT CWaiterDlg::OnReposition(WPARAM, LPARAM)
    {
     SetWindowPos(NULL,
		  0, 0, // top left corner
		  0, 0, // unused
		  SWP_NOSIZE | SWP_NOZORDER);
     return 0;
    } // CWaiterDlg::OnReposition

BOOL CWaiterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	c_Running.ShowWindow(SW_HIDE);

	CheckRadioButton(IDC_ASYNCHRONOUS, IDC_SYNCHRONOUS, IDC_ASYNCHRONOUS);
	updateControls();
	
	PostMessage(UWM_REPOSITION);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWaiterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWaiterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWaiterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWaiterDlg::OnCancel() 
{
 // does nothing: ESCAPE won't close the window
}

void CWaiterDlg::OnOK() 
{
 // does nothing: RETURN won't close the window
}

void CWaiterDlg::OnRun() 
{
 ::ZeroMemory(&info, sizeof(info));
 info.cbSize = sizeof(info);
 info.fMask = SEE_MASK_FLAG_NO_UI | // no message, we handle it
	      SEE_MASK_NOCLOSEPROCESS;
 info.hwnd  = NULL; // now window for messages
 info.lpVerb = NULL; // default verb ("open")
 c_Program.GetWindowText(file);
 info.lpFile = file;
 info.lpDirectory = NULL; // default directory
 info.nShow = SW_SHOW; // default show
 
 BOOL result = ShellExecuteEx(&info);
 if(!result)
    { /* failed */
     reportError(::GetLastError());
     return;
    } /* failed */
	
 if(info.hProcess != NULL)
    { /* wait for it */
     if(c_Asynchronous.GetCheck() == BST_CHECKED)
	{ /* async */
	 c_Running.ShowWindow(SW_SHOW);
	 SetTimer(1, 1000, NULL);
	 running = TRUE;
	 waiter.requestNotification(info.hProcess, this);
	 updateControls();
	} /* async */
     else
	{ /* sync */
	 c_Running.ShowWindow(SW_SHOW);
	 running = TRUE;
	 ::WaitForSingleObject(info.hProcess, INFINITE);
	 running = FALSE;
	} /* sync */
    } /* wait for it */
}

void CWaiterDlg::OnChangeProgram() 
    {
     updateControls();
    }

/****************************************************************************
*                         CWaiterDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates all controls
****************************************************************************/

void CWaiterDlg::updateControls()
    {
     CString s;

     c_Program.GetWindowText(s);
     s.TrimLeft();

     c_Run.EnableWindow(s.GetLength() > 0 && !running);
    } // CWaiterDlg::updateControls

/****************************************************************************
*                           CWaiterDlg::reportError
* Inputs:
*       DWORD err: Error code from GetLastError()
* Result: void
*       
* Effect: 
*       Pops up an informative message box describing the error
****************************************************************************/

void CWaiterDlg::reportError(DWORD err)
    {
     CString s = getErrorString(err);
     AfxMessageBox(s, MB_ICONERROR | MB_OK);
    } // CWaiterDlg::reportError

/****************************************************************************
*                         CWaiterDlg::getErrorString
* Inputs:
*       DWORD err: Error code from GetLastError()
* Result: CString
*       The error explanation
****************************************************************************/

CString CWaiterDlg::getErrorString(DWORD err)
    {
     CString s;
     LPTSTR msg;
     if(::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			err,
			0,
			(LPTSTR)&msg,
			0,
			NULL) == 0)
	{ /* FormatMessage failed */
	 CString fmt;
	 fmt.LoadString(IDS_FORMAT_ERROR);
	 s.Format(fmt, err, (err & 0x0FFFFFFF));
	 return s;
	} /* FormatMessage failed */
     else
	{ /* Success */
	 // Delete the gratuitous CRLF
	 LPTSTR p = _tcschr(msg, _T('\r'));
	 if(p != NULL)
	    *p = _T('\0');
	 s = msg;
	 ::LocalFree(msg);
	 return s;
	} /* Success */
    } // CWaiterDlg::getErrorString

void CWaiterDlg::OnClose() 
{
 CDialog::OnCancel();	
}

void CWaiterDlg::OnTimer(UINT nIDEvent) 
{
	CDialog::OnTimer(nIDEvent);
	c_Running.StepIt();
}

/****************************************************************************
*                       CWaiterDlg::OnProcessTerminated
* Inputs:
*       WPARAM: unused
*	LPARAM: (LPARAM)(HANDLE) process handle
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Handles the process termination notification
****************************************************************************/

LRESULT CWaiterDlg::OnProcessTerminated(WPARAM, LPARAM lParam)
    {
     HANDLE h = (HANDLE)lParam;

     c_Running.ShowWindow(SW_HIDE);
     KillTimer(1);
     running = FALSE;

     updateControls();
     return 0;
    } // CWaiterDlg::OnProcessTerminated

void CWaiterDlg::OnTest() 
{
 test = !test;
 HICON icon = AfxGetApp()->LoadIcon(test ? IDI_JMNCOR : IDI_JMNCO);
 c_Image.SetIcon(icon);	
}
