#include "stdafx.h"

#include "WaitInfo.h"

UINT WaitInfo::UWM_PROCESS_TERMINATED = ::RegisterWindowMessage(UWM_PROCESS_TERMINATED_MSG);

/****************************************************************************
*                        WaitInfo::requestNotification
* Inputs:
*       HANDLE pr: Process handle
*	CWnd * wnd: Window to notify on completion
* Result: void
*       
* Effect: 
*       Spawns a waiter thread
****************************************************************************/

void WaitInfo::requestNotification(HANDLE pr, CWnd * wnd)
   {
    hProcess = pr;
    notifyee = wnd;

    AfxBeginThread(waiter, this);
   } // WaitInfo::requestNotification

/****************************************************************************
*                              WaitInfo::waiter
* Result: void
*       
* Effect: 
*       Waits for the thread to complete and notifies the parent
****************************************************************************/

void WaitInfo::waiter()
    {
     ::WaitForSingleObject(hProcess, INFINITE);
     notifyee->PostMessage(UWM_PROCESS_TERMINATED, 0, (LPARAM)hProcess);
    } // WaitInfo::waiter
